ScriptName SacrosanctAdditionToAddSpells Extends ActiveMagicEffect

GlobalVariable Property PlayerIsVampire Auto
GlobalVariable Property IsSacrosanctInstalled Auto

Spell Property SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew Auto
;Spell Property SCS_VampireSpells_Vanilla_Power_Spell_Nightwalk Auto
Spell Property SCS_VampireSpells_Vanilla_Power_Spell_Flaywind Auto

;Spell Property SCS_VampireSpells_Vanilla_Power_Spell_MindwipeNew Auto
Spell Property SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew Auto
Spell Property SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand Auto
Spell Property SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4 Auto

Spell Property SCS_VampireSpells_Blood_Spell_025_BloodSeed Auto
Spell Property SCS_VampireSpells_Blood_Spell_050_BloodBrand Auto
Spell Property SCS_VampireSpells_Blood_Spell_075_BloodAnkh Auto
;Spell Property SCS_VampireSpells_Blood_Spell_100_BloodGuillotine Auto
Spell Property SCS_VampireSpells_Blood_Spell_100_CurtainCall Auto
Spell Property SCS_VampireSpells_Blood_Spell_100_ProfanedSun Auto
;Spell Property SCS_VampireSpells_Blood_Spell_BloodRune Auto

GlobalVariable Property VampireLordFreedom Auto
SPELL Property DLC1VampireDrain05Alt  Auto  
SPELL Property DLC1VampireDrain06Alt  Auto  
SPELL Property DLC1VampireDrain07Alt  Auto  
SPELL Property DLC1VampireDrain08Alt  Auto  
SPELL Property DLC1VampireDrain09Alt  Auto 

Race Property DLC1VampireBeastRace Auto


Event OnEffectStart(Actor TargetActor, Actor Caster)

	Utility.Wait(10.0)

	Int SacrosanctSpellsAdded = 0

	If PlayerIsVampire.GetValue() == 1 && IsSacrosanctInstalled.GetValue() == 10000
	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf			
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		
		;If SacrosanctSpellsAdded == 1
		;	Debug.Notification("Sacrosanct Spells have been added!")
		;EndIf
		
	ElseIf PlayerIsVampire.GetValue() == 0 || IsSacrosanctInstalled.GetValue() == 0

		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun)
		
	EndIf		
			
	;RegisterForUpdateGameTime(1.0)		
			
EndEvent




Function OnUpdateGameTime()

	;If PlayerIsVampire.GetValue() == 0 || IsSacrosanctInstalled.GetValue() == 0

	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall)
	;	Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun)
		
	;	UnregisterForUpdateGameTime()
		
	;EndIf		

EndFunction




Event OnLoad()

	Utility.Wait(5.0)

	;UnregisterForUpdateGameTime()

	Int SacrosanctSpellsAdded = 0

	If PlayerIsVampire.GetValue() == 1 && IsSacrosanctInstalled.GetValue() == 10000
	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf			
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		
		;If SacrosanctSpellsAdded == 1
		;	Debug.Notification("Sacrosanct Spells have been added!")
		;EndIf
		
	ElseIf PlayerIsVampire.GetValue() == 0 || IsSacrosanctInstalled.GetValue() == 0

		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun)
		
	EndIf		
			
	;RegisterForUpdateGameTime(1.0)	
	
	;---------------------------------------------------------------------------------------
	
	If VampireLordFreedom.GetValue() == 10000
		Utility.Wait(2.0)
		If Game.GetPlayer().GetRace() == DLC1VampireBeastRace
			Game.SetBeastForm(False)
			Game.EnableFastTravel()
			;Debug.Notification("Beast Form = False  Fast Travel = True")
			Game.EnablePlayerControls(abMovement = true, abFighting = true, abCamSwitch = true, abMenu = true, abActivate = true, abJournalTabs = true, aiDisablePOVType = 0)
			
			; Add the leveled Vampire Lord Drain spell
			If  Game.GetPlayer().GetLevel() <= 10 && Game.GetPlayer().HasSpell(DLC1VampireDrain05Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain05Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel() > 10 && Game.GetPlayer().GetLevel() <= 20 && Game.GetPlayer().HasSpell(DLC1VampireDrain06Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain06Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 20 && Game.GetPlayer().GetLevel() <= 30 && Game.GetPlayer().HasSpell(DLC1VampireDrain07Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain07Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 30 && Game.GetPlayer().GetLevel() <= 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain08Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain08Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain09Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain09Alt, abVerbose = False)
			Endif
		EndIf	
	EndIf

EndEvent




Event OnPlayerLoadGame()

	Utility.Wait(5.0)

	;UnregisterForUpdateGameTime()

	Int SacrosanctSpellsAdded = 0

	If PlayerIsVampire.GetValue() == 1 && IsSacrosanctInstalled.GetValue() == 10000
	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf			
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf	
		If Game.GetPlayer().HasSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun) == False
			Game.GetPlayer().AddSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun, abVerbose = False)
			SacrosanctSpellsAdded = 1
		EndIf
		
		;If SacrosanctSpellsAdded == 1
		;	Debug.Notification("Sacrosanct Spells have been added!")
		;EndIf
		
	ElseIf PlayerIsVampire.GetValue() == 0 || IsSacrosanctInstalled.GetValue() == 0

		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun)
		
	EndIf		
			
	;RegisterForUpdateGameTime(1.0)	
	
	;---------------------------------------------------------------------------------------
	
	If VampireLordFreedom.GetValue() == 10000
		Utility.Wait(2.0)
		If Game.GetPlayer().GetRace() == DLC1VampireBeastRace
			Game.SetBeastForm(False)
			Game.EnableFastTravel()
			;Debug.Notification("Beast Form = False  Fast Travel = True")
			Game.EnablePlayerControls(abMovement = true, abFighting = true, abCamSwitch = true, abMenu = true, abActivate = true, abJournalTabs = true, aiDisablePOVType = 0)
			
			; Add the leveled Vampire Lord Drain spell
			If  Game.GetPlayer().GetLevel() <= 10 && Game.GetPlayer().HasSpell(DLC1VampireDrain05Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain05Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel() > 10 && Game.GetPlayer().GetLevel() <= 20 && Game.GetPlayer().HasSpell(DLC1VampireDrain06Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain06Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 20 && Game.GetPlayer().GetLevel() <= 30 && Game.GetPlayer().HasSpell(DLC1VampireDrain07Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain07Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 30 && Game.GetPlayer().GetLevel() <= 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain08Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain08Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain09Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain09Alt, abVerbose = False)
			Endif
		EndIf	
	EndIf

EndEvent




Event OnEffectFinish(Actor TargetActor, Actor Caster)

	Utility.Wait(10.0)

	If PlayerIsVampire.GetValue() == 0 || IsSacrosanctInstalled.GetValue() == 0

		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_MytherceriaNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_Flaywind)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_NightwalkNew)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresCommand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Vanilla_Power_Spell_VampiresWill_Stage4)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_025_BloodSeed)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_075_BloodAnkh)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_050_BloodBrand)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_CurtainCall)
		Game.GetPlayer().RemoveSpell(SCS_VampireSpells_Blood_Spell_100_ProfanedSun)
		
	EndIf	
	
EndEvent
