Scriptname VampireLordTransformAdditions extends activemagiceffect

PlayerVampireQuestScript Property PlayerVampireQuest  Auto 

GlobalVariable Property VampireFeedReady  Auto 
GlobalVariable Property VampireStageGlobal Auto
GlobalVariable Property VampireLordFreedom Auto
SPELL Property DLC1VampireDrain05Alt  Auto  
SPELL Property DLC1VampireDrain06Alt  Auto  
SPELL Property DLC1VampireDrain07Alt  Auto  
SPELL Property DLC1VampireDrain08Alt  Auto  
SPELL Property DLC1VampireDrain09Alt  Auto 

Race Property DLC1VampireBeastRace Auto

;==============================================================================================

EVENT OnEffectStart(Actor akTarget, Actor akCaster)

	Utility.Wait(12.0)
	
	If VampireLordFreedom.GetValue() == 10000
		;Utility.Wait(5.0)
		If Game.GetPlayer().GetRace() == DLC1VampireBeastRace
			Game.SetBeastForm(False)
			Game.EnableFastTravel()
			;Debug.Notification("Beast Form = False  Fast Travel = True")
			Game.EnablePlayerControls(abMovement = true, abFighting = true, abCamSwitch = true, abMenu = true, abActivate = true, abJournalTabs = true, aiDisablePOVType = 0)
			
			; Add the leveled Vampire Lord Drain spell
			If  Game.GetPlayer().GetLevel() <= 10 && Game.GetPlayer().HasSpell(DLC1VampireDrain05Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain05Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel() > 10 && Game.GetPlayer().GetLevel() <= 20 && Game.GetPlayer().HasSpell(DLC1VampireDrain06Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain06Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 20 && Game.GetPlayer().GetLevel() <= 30 && Game.GetPlayer().HasSpell(DLC1VampireDrain07Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain07Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 30 && Game.GetPlayer().GetLevel() <= 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain08Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain08Alt, abVerbose = False)
			Elseif Game.GetPlayer().GetLevel()  > 40 && Game.GetPlayer().HasSpell(DLC1VampireDrain09Alt) == False
				Game.GetPlayer().AddSpell(DLC1VampireDrain09Alt, abVerbose = False)
			Endif
		EndIf	
	EndIf	

	;========================================		
	
	;Debug.Notification("Regular Vampire Abilities now applied.")	
	
	If VampireStageGlobal.GetValue() == 4
		PlayerVampireQuest.VampireStatus = 4
		VampireFeedReady.SetValue(3)			
	ElseIf VampireStageGlobal.GetValue() == 3
		PlayerVampireQuest.VampireStatus = 3
		VampireFeedReady.SetValue(2)
	ElseIf VampireStageGlobal.GetValue() == 2
		PlayerVampireQuest.VampireStatus = 2
		VampireFeedReady.SetValue(1)
	ElseIf VampireStageGlobal.GetValue() == 1
		PlayerVampireQuest.VampireStatus = 1
		VampireFeedReady.SetValue(0)
	EndIf	
			
	PlayerVampireQuest.VampireProgression(Game.GetPlayer() as Actor, VampireStageGlobal.GetValue() as Int)			
	
EndEvent

;==============================================================================================

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	
			
EndEvent
